<p align="center">
  <img src="./assets/logo.png" style="max-width: 50%;"/>
</p>

---

Neural network library written in Python completely from scratch, using only numpy.

## Usage

```
import nn

a, b = Tensor(2), Tensor(3)
c = a.mul(b)
d = c.exp()
d.backward()

print(a.grad, b.grad, c.grad)
# should output (1210.2863804782053, 806.8575869854702, 403.4287934927351)
```

## References

- <https://github.com/geohot/tinygrad/>
- <https://github.com/karpathy/micrograd/>

## Copying

This is free and unencumbered software released into the public domain.
